%module "Darts"
%{
#include "darts_impl.h"
%}


%typemap(in) (size_t size, char** str, size_t* len) {
    if (!SvROK($input)) {
        SWIG_croak("type errorr");
    }

    AV* av = (AV *) SvRV($input);
    if (SvTYPE(av) != SVt_PVAV) {
        SWIG_croak("type errorr");
    }

    $1 = av_len(av);
    $2 = new char*[$1];
    $3 = new size_t[$1];
    for (int i = 0; i < $1; i++) {
        SV** s = av_fetch(av, i, 0);
        $2[i] = SvPV(*s, $3[i]);
    }
}

%typemap(freearg) (size_t size, char** str, size_t* len) {
    delete[] $2;
    delete[] $3;
}

%typemap(in) (const char* str, size_t len) {
    $1 = SvPV($input, $2);
}

%include "std_vector.i"

namespace std {
    %template(vectori) vector<int>;
}

%include "darts_impl.h"
