#include <darts.h>

#define DEFAULT_RESULT_SIZE 10

class DoubleArray {
public:
    int build(size_t size, char** str, size_t* len) 
    {
        return darts.build(size, str, len);
    }

    std::vector<int> commonPrefixSearch(const char* str, size_t len)
    {
        int n;
        std::vector<int> result(DEFAULT_RESULT_SIZE);

        n = darts.commonPrefixSearch(str, &result[0], result.size(), len);
        if (n > result.size()) {
            result.resize(n);
            n = darts.commonPrefixSearch(str, &result[0], result.size(), len);
        }

        result.resize(n);

        return result;
    }

    int exactMatchSearch(const char* str, size_t len) {
        int r;
        darts.exactMatchSearch(str, r, len, 0);
        return r;
    }

    int save(const char* filename) {
        return darts.save(filename);
    }

    int open(const char* filename) {
        return darts.open(filename);
    }

    size_t size() {
        return darts.size();
    }
private:
    Darts::DoubleArray darts;
};
